
const htmlTags = [
  'address',
  'article',
  'aside',
  'base',
  'basefont',
  'blockquote',
  'body',
  'caption',
  'center',
  'col',
  'colgroup',
  'dd',
  'details',
  'dialog',
  'dir',
  'div',
  'dl',
  'dt',
  'fieldset',
  'figcaption',
  'figure',
  'footer',
  'form',
  'frame',
  'frameset',
  'h1',
  'h2',
  'h3',
  'h4',
  'h5',
  'h6',
  'head',
  'header',
  'hr',
  'html',
  'iframe',
  'legend',
  'li',
  'link',
  'main',
  'menu',
  'menuitem',
  'nav',
  'noframes',
  'ol',
  'optgroup',
  'option',
  'p',
  'param',
  'search',
  'section',
  'summary',
  'table',
  'tbody',
  'td',
  'tfoot',
  'th',
  'thead',
  'title',
  'tr',
  'track',
  'ul',
];
export function addCustomClassPlugin(md) {
  const addCustomClass = (state) => {
    state?.tokens?.forEach((token) => {
      if (htmlTags.includes(token.tag)) {
        // 添加自定义类
        token.attrJoin('class', token.tag);
      }
    });
  };
  md.core.ruler.push('addCustomClass', addCustomClass);
}


function renderCode(origRule, options) {
    options ={...options}
	return (...args) => {
		const [tokens, idx] = args;
		const content = tokens[idx].content
			.replaceAll('"', '&quot;')
			.replaceAll("'", "&apos;");
		const origRendered = origRule(...args);

		if (content.length === 0)
			return origRendered;

		return `
<div  style="position: relative" >
    ${origRendered}
    <a class="__preCodeCopyWrap" href="${content}"></a>
</div>
`;
	};
}

export const copy = (md, options) => {
	md.renderer.rules.code_block = renderCode(md.renderer.rules.code_block, options);
	md.renderer.rules.fence = renderCode(md.renderer.rules.fence, options);
};


